//$D-,L-,O+,Q-,R-,Y-,S-}
program CopyInfo2Clip;
{$APPTYPE CONSOLE}
uses
  SysUtils,
  windows,
  classes,
  IniFiles,
  dialogs,
  SomeStuff in 'SomeStuff.pas';
{$E exe}

type
tPackDefaultParamStruct=record
    size,
    PluginInterfaceVersionLow,
    PluginInterfaceVersionHi:longint;
    DefaultIniName:array[0..258] of char;
  end;
  pPackDefaultParamStruct=^tPackDefaultParamStruct;
  tCopyWdxInfoToClip=function(AddList,NomDuSchema,DefPath,DestFile,myini,src:pchar;finalStream:TMemoryStream):integer; stdcall;
  tInitializeMyPlugin=procedure(dps:pPackDefaultParamStruct); stdcall;
  var j:integer;
    s,s1,s2:string;
    filename:string;
    Liste,List:tstringlist;
    schemename:string;
    myIni4Copy:TInifile;
    path:string; ModName: array[0..260] of Char;
    dll2load:string;
    path2give,myiniPath:string;
    myLib:THandle;
    i,k:integer;
    theWholeList:array of char;
    Proc1:tCopyWdxInfoToClip;
    Proc0:tInitializeMyPlugin;
    dps :tPackDefaultParamStruct;
    sizeMax:cardinal;
    myEnd:TMemoryStream;
    globVal,p:pchar;

    src:pchar;
begin
        fillchar(theWholeList,sizeof(theWholeList),#0);
        Fillchar(ModName,sizeof(ModName),#0);
        SetString(path, ModName,Windows.GetModuleFileName(0, ModName, SizeOf(ModName)));
        path:=ExtractFilePath(path)+'WdxInfoPacker.ini';
        myIni4Copy:=TIniFile.Create(ExtractFilePath(path)+'CopyInfo2Clip.ini');
        path2give:=myIni4Copy.ReadString('Main','pathSend2Wdx','c:\totalcmd\contplug.ini');
        myiniPath:=myIni4Copy.ReadString('Main','WdxInfoPacker.ini','c:\totalcmd\WdxInfoPacker.ini');
        dll2load:=myIni4Copy.ReadString('Main','WdxInfoPacker.wcx',ExtractFilePath(path)+'WdxInfoPacker.wcx');

        if not FileExists(myiniPath) then begin
         MessageBox(GetActiveWindow,'Invalid WdxInfoPacker.ini path in your CopyInfo2Clip.ini','Warning',MB_OK or MB_ICONEXCLAMATION);
         exit
        end;
        if not FileExists(dll2load) then begin
         MessageBox(GetActiveWindow,'Invalid WdxInfoPacker.wcx path in your CopyInfo2Clip.ini','Warning',MB_OK or MB_ICONEXCLAMATION);
         exit
        end;


	s:=ParamStr(0);
        schemename:='';
        filename:='';
        liste:=tstringlist.create;
	for j := 1 to ParamCount do begin
		if (pos('/L=', pchar(ParamStr(j)))<>0) then begin
                   s2:=StringReplace(ParamStr(j),'_', '1@1',[rfReplaceAll, rfIgnoreCase]);
                   s2:=StringReplace(s2,' ', '_',[rfReplaceAll, rfIgnoreCase]);
                   Split('=',s2,liste);
                   filename:=liste[1];
		end
                else if(pos('/S=', pchar(ParamStr(j)))<>0) then begin
                   s1:=StringReplace(ParamStr(j),' ', '2_2',[rfReplaceAll, rfIgnoreCase]);
                   Split('=',s1,liste);
                   schemename:=StringReplace(liste[1],'2_2',' ',[rfReplaceAll, rfIgnoreCase]);
                end
	end;
        myIni4Copy.Free;
        if length(schemename)=0 then begin
             myIni4Copy:=TIniFile.Create(ExtractFilePath(path)+'scheme.use');
             schemename:=myIni4Copy.ReadString('Main','scheme','');
        end;
        if length(schemename)=0 then exit ;
        filename:=StringReplace(filename,'_', ' ',[rfReplaceAll, rfIgnoreCase]);
        filename:=StringReplace(filename,'1@1', '_',[rfReplaceAll, rfIgnoreCase]);
        List:=TStringList.Create;
        //read the file given from TC in %L parameter & creating the big string...
        List:=getAllFileList(pchar(filename));
        if  ExtractFilePath(List[0])=List[0] then begin
           k:=getLastPos('\',pchar(List[0]));
           src:=StrAlloc(k*sizeof(char));
           FillMemory(src,k,0); 
           StrLCopy(src,pchar(List[0]),k-1); 
        end else begin
           k:=Length(ExtractFilePath(List[0]));
           src:=StrAlloc(k*sizeof(char));
           FillMemory(src,k,0);
           StrLCopy(src,pchar(ExtractFilePath(List[0])),k-1);
        end;
//        if (List[0]<>src) then List[0]:=StringReplace(List[0],src , '',[rfReplaceAll, rfIgnoreCase]);
        sizeMax:=0;
        k:=List.count-1;
        for i:=0 to k do begin
         List[i]:=StringReplace(List[i],src , '',[rfReplaceAll, rfIgnoreCase]);
         sizeMax:=sizeMax+Length(List[i])+1;
        end;
         sizeMax:=SizeMax+1;
        globVal:=StrAlloc(sizeMax*sizeof(char));
        FillMemory(globVal,sizeMax*sizeof(char),0);
        p:=globVal;
        for i:=0 to k do begin
         if i<>0 then begin
          p:=StrEnd(p);
          inc(p);
         end;
         StrCat(p,pchar(List[i]));
        end;
        List.free;
        dps.PluginInterfaceVersionLow:=4;
        dps.PluginInterfaceVersionHi:=1;
        strlcat(dps.DefaultIniName,pchar(path2give),sizeof(dps.DefaultIniName));
        myLib:= LoadLibrary(pchar(dll2load));
        if myLib=0 then Exit
        else begin
         @Proc0:=GetProcAddress(myLib,'PackSetDefaultParams');
         if @proc0 <>nil then begin
          Proc0(@dps);
          @Proc1:=GetProcAddress(myLib,'CopyWdxInfoToClip');
          if @Proc1<>nil then begin
           myEnd:=TMemoryStream.Create;
           Proc1(globVal,pchar(schemename),pchar(path2give),'', pchar(myiniPath),src,myEnd);
           myEnd.Seek(0,0);
           if myEnd.Size >0 then LoadData2Clip(myEnd,myEnd.size);
           myEnd.Clear;
           myEnd.Free;
          end;
         end;
         FreeLibrary(myLib);
        end;
        StrDispose(globVal);
        StrDispose(src);
        Liste.Free;
end.
